$(function () {
  $.extend({
    scrollTo: function (type, duration, options) {
      if (typeof type == "object") {
        $(type).offset().top;
      }
      $("html, body").animate(
        { scrollTop: type },
        {
          duration: duration,
          queue: options.queue,
        }
      );
    },
  });
  // show search field
  $("#search-link").click(function () {
    $("#search-field").toggle();
  });
  // mobile show nav
  $("#nav-toggle").click(function () {
    $("#site-nav").toggleClass("show-block");
  });
  // guestbook
  $("#get-captcha").click(function (e) {
    $.get(
      "/api/captcha",
      function (res) {
        $("#captcha_id").attr("value", res.data.captcha_id);
        $("#get-captcha").attr("src", res.data.captcha);
      },
      "json"
    );
  });
  $("#get-captcha").click();

  // show toc
  if ($(".post-content").length) {
    let parentTag = null;
    let deep = 0;
    let contentTpl = '<div class="toc-article" id="toc"><ol>';
    $(".post-content")
      .find("h1,h2,h3,h4,h5,h6")
      .each(function (i, item) {
        let tagLeaf = $(item).prop("tagName").toUpperCase().replace("H", "");
        if (!parentTag) {
          parentTag = tagLeaf;
          deep = 0;
        }
        if (parentTag > tagLeaf) {
          deep -= parentTag - tagLeaf;
        } else if (parentTag < tagLeaf) {
          deep -= parentTag - tagLeaf;
          parentTag = tagLeaf;
        }
        let titleText = $(item).text();
        let titleId = "toc-" + i;
        $(item).attr("id", titleId);

        contentTpl += `<li class="toc-item level-${deep}"><a href="#${titleId}">${titleText}</a></li>`;
      });
    contentTpl += "</ol></div>";
    if (parentTag) {
      $(".sidebar").append(contentTpl);
      $(document).on("click", "#toc a", function (e) {
        e.preventDefault();
        let id = $(this).attr("href");
        $.scrollTo($(id).offset().top - 50, 500, { queue: true });

        let othis = $(this).parent();
        othis.addClass("active");
        othis.siblings().removeClass("active");
      });

      var tocToTop = $("#toc").offset().top;
      function reLayout() {
        let scrollToTop =
          document.documentElement.scrollTop || window.pageYOffset; // Safari is special
        if (tocToTop === 0) {
          // Fix bug that when resize window the toc layout may be wrong
          $("#toc").removeClass("toc-fixed");
          tocToTop = $("#toc").offset().top;
        }
        if (tocToTop <= scrollToTop + 10) {
          if (!$("#toc").hasClass("toc-fixed")) {
            $("#toc").addClass("toc-fixed");
          }
        } else if ($("#toc").hasClass("toc-fixed")) {
          $("#toc").removeClass("toc-fixed");
        }

        let minTop = 9999;
        let minTopsValue = "";

        $("#toc a").each(function (_, item) {
          let link = decodeURIComponent($(item).attr("href")).replace(/^#/, "");
          if (!$("#" + link).length) {
            return;
          }
          let toTop = $("#" + link).offset().top - scrollToTop;
          if (Math.abs(toTop) < minTop) {
            minTop = Math.abs(toTop);
            minTopsValue = link;
            $(item)
              .parent()
              .addClass("active")
              .siblings()
              .removeClass("active");
          }
        });
      }

      reLayout();

      window.addEventListener("scroll", function (e) {
        reLayout();
      });
    }
  }
});
